package l_encrypt

import (
	"fmt"
	"gitea.cdlsxd.cn/self-tools/l_crypt/encrypt_way/aes"
)

func NewAES(app *AppEncrypt) ApiCrypt {
	return &AES{
		App: app,
	}
}

func (r *AES) Encrypt(data string) (encryptData []byte, err error) {

	encrypt, err := aes.Encrypt(r.App.UniKEY, data)
	if err != nil {
		return nil, fmt.Errorf("加密失败")
	}

	return []byte(encrypt), nil
}

func (r *AES) Decrypt(encryptData string) (decryptData []byte, err error) {
	decrypt, err := aes.Decrypt(r.App.UniKEY, encryptData)
	if err != nil || decrypt == "" {
		return nil, fmt.Errorf("解密失败")
	}
	return []byte(decrypt), nil
}
